/**
 * 
 */
package cs307.first;

import cs307.first.BitVector.Builder;
import cs307.first.BitVector.Descriptor;

/**
 * @author -
 *
 */
public class BuilderSmall_1 implements Builder {

	private Descriptor desc;
	
	public BuilderSmall_1(Descriptor d) {

		this.desc = d;
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Builder#buildBitVector()
	 */
	@Override
	public BitVector buildBitVector() {
		
		return new BitVectorSmall_1(desc.getUpperBound(),
				desc.getLowerBound(),
				desc.boundCheckRequired(),
				this);
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Builder#buildBitVector(cs307.first.BitVector)
	 */
	@Override
	public BitVector buildBitVector(BitVector val) {

		return (BitVector) val.builder().build();
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Builder#compatible(cs307.first.BitVector.Builder)
	 */
	@Override
	public boolean compatible(Builder other) {

		return this.equals(other);
	}

	/* (non-Javadoc)
	 * @see cs307.first.Director.Builder#build()
	 */
	@Override
	public Object build() {

		return buildBitVector();
	}

}
