package cs307.first;

public class Runner_1 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		final Director director = new Director_1();
		
		final BitVector.Descriptor small = new BitVector.Descriptor(0, 31, false, true, true);
		final BitVector.Descriptor big = new BitVector.Descriptor(0, 31, true, false, true);
		
		final BitVector.Builder builder1 = (BitVector.Builder) director.makeBuilder(big);
		final BitVector.Builder builder2 = (BitVector.Builder) director.makeBuilder(small);
		
		BitVector bs1 = (BitVector) builder2.build();
		BitVector bs2 = (BitVector) builder2.build();
		
		
		bs1.set(1);
		bs1.set(3);
		
		bs2.set(0);
		bs2.set(7);
		bs2.set(3);
		bs2.set(12);
		
		bs1.xor(bs2);
		
		System.out.println("Testing...");
		System.out.println("01234567890123456789");
		for(int i = 0; i < 20; i++) {
			if (bs1.test(i)) {
				System.out.print("1");
			} else {
				System.out.print("0");
			}
		}
		System.out.println("");
	}

}
