package test.first.u19;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import threeohseven.BitVector;

import cs307.first.BitVector_19;
import cs307.first.Director_19;

public class Director_19Test {
	Director_19 d;
	@Before
	public void setUp() throws Exception {
		d = new Director_19();
	}

	@After
	public void tearDown() throws Exception {
		d = null;
	}

	

	@Test
	public void testMakeBuilder() {
		final BitVector.Descriptor small = new BitVector.Descriptor(0, 31, false, true, true);
		final BitVector.Builder builder =  (BitVector.Builder) d.makeBuilder(small);
		assertEquals("Upperbound of Descriptor test",small.getUpperBound(), 31);
		assertEquals("Lowerbound of Descriptor test",small.getLowerBound(), 0);
		BitVector_19 bv = (BitVector_19) builder.buildBitVector();
		assertEquals("That it built a bv", bv.test(0), false);
	}

}
