package cs307.first;

import threeohseven.BitVector;
import threeohseven.BitVector.Descriptor;

/**
 * Builds fast BitVectors with the defined descriptor.
 * @author -
 */
public class Builder_23_speed extends Builder_23_base{

    public Builder_23_speed(Descriptor d) {
        super(d);
    }

    public BitVector buildBitVector() {
        return new BitVector_23_speed(this,descriptor.boundCheckRequired(),descriptor.getLowerBound(),descriptor.getUpperBound());
    }


}
