package cs307.first;

import threeohseven.BitVector;
import threeohseven.Director;

/**
 *
 * @author -
 */
public class Director_23 implements Director {

    public BitVector.Builder makeBuilder(Descriptor dd) {
        if (dd instanceof BitVector.Descriptor) {
            BitVector.Descriptor descriptor = (BitVector.Descriptor) dd;
            if (descriptor.optimizeSpace() && descriptor.optimizeSpeed()) { //Optimize Space and speed?
                return new Builder_23_space_and_speed(descriptor); //Then return a space and speed Builder
            } else if (descriptor.optimizeSpace()) { //Optimize just space?
                return new Builder_23_space(descriptor); //Then return a space Builder
            } else if (descriptor.optimizeSpeed()) { //Optimize just speed?
                return new Builder_23_speed(descriptor); //Then return a speed Builder
            } else { //Optimize Neither?
                return new Builder_23_space_and_speed(descriptor); //Then return a space and speed builder.
            }
        }
        return null; //If its not a BitVector Descriptor, then we can't build a bitvector now can we?
    }
}
