package cs307.first;

import threeohseven.BitVector;
import threeohseven.BitVector.Builder;

public class BuilderB_46 implements Builder {
	public int min;
	public int max;
	public boolean checked;

	@Override
	public BitVector buildBitVector() {
		BitVectorB_46 bv = new BitVectorB_46(min, max, checked);
		bv.builder = this;
		return bv;
	}

	@Override
	public BitVector buildBitVector(BitVector val) {
		BitVectorB_46 copy = new BitVectorB_46(min, max, checked);
		copy.or(val);
		return copy;
	}

	@Override
	public boolean compatible(Builder other) {
		if (other.equals(this)) {
			return true;
		}
		return false;
	}

	@Override
	public Object build() {
		return buildBitVector();
	}

}
