package cs307.first;

import threeohseven.BitVector.Iterator;

public class IteratorS_46 implements Iterator {
	private BitVectorS_46 _bv;
	int _position = 0;
	
	public IteratorS_46(BitVectorS_46 bv) {
		_bv = bv;
		_position = _bv._min;
	}
	
	@Override
	public boolean getNext() {
		if (hasNext()) {
			++_position;
			return _bv._bv[_position-1];
		}
		else {
			return false;
		}
	}

	@Override
	public boolean hasNext() {
		if (_position > _bv._max) {
			return false;
		}
		else {
			return true;
		}
	}

	@Override
	public int position() {
		return _position;
	}

	@Override
	public int skipToSet() {
		while (_bv._bv[_position] == false) {
			_position++;
		}
		return _position;
	}

	@Override
	public int skipToUnset() {
		while (_bv._bv[_position] == true) {
			_position++;
		}
		return _position;
	}

}
