/*****
 * Package cs307.first - BuilderSpeed_u49
 *****/

package cs307.first;

/**
 * @author -
 *
 */
public class BuilderSpeed_u49 implements BitVector.Builder {
	
	public BitVector.Descriptor des;
	
	public Object build() {
		return buildBitVector();
	}
	
	public BuilderSpeed_u49 (Director.Descriptor base) {
		des = (BitVector.Descriptor) base;
	}
	
	public BitVector buildBitVector() {
		return new BitVectorSpeed_u49(des.getLowerBound(), des.getUpperBound(), this);
	}
	
	public BitVector buildBitVector(BitVector val) {
		if (des.equals(((BitVectorSpeed_u49) val).descriptor))
			return val.copy();
		else
			throw new cs307.first.ImplementationError("Incompatible Bit Vector Types.");
	}
	
	public boolean equals(Object other) {
		if (other instanceof BuilderSpeed_u49)
			return compatible((BitVector.Builder) other);
		else
			return false;
	}
	
	public boolean compatible(BitVector.Builder other) {
		if (other instanceof BuilderSpeed_u49)
			return des.equals(((BuilderSpeed_u49) other).des);
		else
			return false;
	}
}
