/*****
 * 
 *****/

package cs307.first;

/**
 * @author -
 *
 */
public class Iterator_u49 implements BitVector.Iterator {
	private BitVector src;
	private int pos;
	
	/**
	 * @param owner
	 */
	public Iterator_u49 (BitVector owner) {
		src = owner;
	}
	
	public boolean hasNext() {
		try {
			src.test(pos+1);
		} catch (BitVector.NoSuchElementError e) {
			return false;
		}
		
		return true;
	}

	public boolean getNext() {
		if (hasNext()) {
			pos++;
			return src.test(pos);
		} else {
			throw new BitVector.NoSuchElementError("Iterator at end.");
		}
	}

	public int position() {
		return pos;
	}

	public int skipToSet() {
		while (!src.test(pos)) {
			if (hasNext())
				pos++;
			else
				throw new BitVector.NoSuchElementError("Iterator at end.");
		}
		
		return pos;
	}

	public int skipToUnset() {
		while (src.test(pos)) {
			if (hasNext())
				pos++;
			else
				throw new BitVector.NoSuchElementError("Iterator at end.");
		}
		
		return pos;
	}
	
}
