package cs307.first;

//import first.BitVector_51.Builder_51;
//import threeohseven.BitVector;
//import threeohseven.BitVector.Builder;
import cs307.threeohseven.*;
import cs307.first.Descriptor_51;
/**
 * The Builder interface returns constructed objects. This is the
 * generic version which return values of Object type. Implementations
 * may choose to provide more specific methods.
 *
 * @author -
 **/
/**
 * Builder creates new  <code>BitVector</code> objects. <p>
 *
 * @author -
 * @author -
 **/
public class Builder_51 implements cs307.threeohseven.BitVector.Builder {
    public Descriptor_51 desc;
    
    /**
     * Return a new empty BitVector.  Use current descriptor if available.
     **/
    public BitVector buildBitVector()
    {
    	BitVector_51 newBV;
    	if(this.desc != null)
    		newBV = new BitVector_51(this.desc);
    	else
    		newBV = new BitVector_51();
    	
        return newBV;
    }
    
    /**
     * Returns a new BitVector identical to <code>val</code>. This is a
     * deep copy in the sense that there is no logical sharing of
     * mutable state between the two objects.
     * @throws ImplementationError if the argument's builder
     *  is not compatible  with the reciever.
     **/
    public BitVector buildBitVector(BitVector val)
    {
    		BitVector_51 newBV = (BitVector_51)(val.copy());
    		return (BitVector)newBV;
    }

    /**
     * Returns true if the two builders are compatible. This method is
     * required to return true if the builders are
     * <code>.equals</code>. For builders of different classes the         * method returns true when the implementation is able to convert between
     * representations. <p>
     **/
    public boolean compatible(cs307.threeohseven.BitVector.Builder other)
    {return false;}
    public boolean compatible(Builder_51 other)
    {
            //TODO: check internal values of builders
         //   if( (this.desc.low_ == other.desc.low_) && (this.desc.high_ == other.desc.high_) && (this.desc.optSpace_ == other.desc.optSpace_) && (this.desc.optSpeed_ == other.desc.optSpeed_) && (this.desc.checked_ == other.desc.checked_)  );
        //            return true;

            return false;
    }

    /** 
     * Build generic object.  Useless in this implementation.
     */
	public Object build()
	{
		//build crap
		Object o = new Object();
		return o;
	}

	/** 
	 *  Generic empty constructor
	 */
    public Builder_51()
    {
    }

    /**
     * Constructor that sets desc
     * @param d Descriptor_51
     */
    public Builder_51(Descriptor_51 d)
    {
            desc = d;
    }
    
    /*
     *  Generic constructor takes old implementation of Descriptor.
     */
    public Builder_51(cs307.threeohseven.BitVector.Descriptor d)
    {    }

    /*
     *  Generic constructor takes old implementation of Descriptor.
     */
    public Builder_51(cs307.threeohseven.Director.Descriptor d)
    {    }
 
    /**
     * Builds bit vector from another bit vector.
     * @param val which is a BitVector
     * @return new BitVector
     */
    public BitVector_51 buildBitVector(BitVector_51 val)
    {
           //TODO: check builder compatibility
           BitVector_51 newBV = (BitVector_51)  (((BitVector)val).copy());
           return newBV;
    }

    /**
     * Checks is this bitVector_51 object is equal to object other
     * @param other which is an object
     * @return boolean - true if objects are equal, false if otherwise
     */
    public boolean equals(Object other)
    {
    		if(other.equals(new Builder_51()))
    				return true;
            return false;
    }
}
