package cs307.first.test.u51;

import junit.framework.TestCase;
import junit.framework.Assert;
import cs307.first.*;

public class TestNegate extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void test()
	{
		//first test speed-optimized vector
		Director_51 director = new Director_51();
		//we do not need to set speed-optimize flag, we automatically speed optimize unless space-optimized flag set
		Descriptor_51 desc = new Descriptor_51(0,6,false,false,false);
		Builder_51 builder = director.makeBuilder(desc);
		
		BitVector_51 bv1 = new BitVector_51(desc);
		bv1.set(1);
		bv1.set(3);
		bv1.set(5);
		boolean forAssert = true;

		String holdingString;
		holdingString = bv1.toString();
		System.out.println(holdingString);
		
		if(holdingString.charAt(0)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(2)=='0')  //should have a one
		{
			forAssert=false;
		}
		else if(holdingString.charAt(4)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(6)=='0')  //should have a one
		{
			forAssert=false;
		}
		else if(holdingString.charAt(8)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(10)=='0')  //should have a one
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
		
		bv1.negate(0);
		bv1.negate(1);
		bv1.negate(2);
		bv1.negate(3);
		bv1.negate(4);
		bv1.negate(5);
		holdingString = bv1.toString();
		System.out.println(holdingString);
		
		if(holdingString.charAt(0)=='0')  //should have a one
		{
			forAssert=false;
		}
		else if(holdingString.charAt(2)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(4)=='0')  //should have a one
		{
			forAssert=false;
		}
		else if(holdingString.charAt(6)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(8)=='0')  //should have a one
		{
			forAssert=false;
		}
		else if(holdingString.charAt(10)=='1')  //should have a zero
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
	}
	protected void tearDown() throws Exception {
		super.tearDown();
	}

}
