package cs307.first.test.u51;

import junit.framework.TestCase;
import junit.framework.Assert;
import cs307.first.*;

public class TestSetUnset extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void test()
	{
		//first test speed-optimized vector
		Director_51 director = new Director_51();
		//we do not need to set speed-optimize flag, we automatically speed optimize unless space-optimized flag set
		Descriptor_51 desc = new Descriptor_51(0,6,false,false,false);
		Builder_51 builder = director.makeBuilder(desc);
		
		BitVector_51 bv1 = new BitVector_51(desc);
		bv1.set(0);
		bv1.set(1);
		bv1.set(2);
		bv1.set(3);
		bv1.set(4);
		bv1.set(5);
		boolean forAssert = true;
		if(bv1.toString().indexOf("0")!=-1)  //should have no zeros in it
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
		bv1.unset(0);
		bv1.unset(1);
		bv1.unset(2);
		bv1.unset(3);
		bv1.unset(4);
		bv1.unset(5);
		if(bv1.toString().indexOf("1")!=-1)  //should have no ones in it
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
	}
	protected void tearDown() throws Exception {
		super.tearDown();
	}

}
