/**
 * The ImplementationError class for 307-PA1
 **/
package threeohseven;

/**
 * Thrown if an implementation can not handle a request. This error is used
 * when requesting a method that is not supported by a particular
 * implementation or when passed arguments of an inappropriate type.  <p>
 * 
 * This is an unchecked error since it signals a, normally, fatal
 * misconfiguration, it is therefore usually only caught at the top level.
 *
 * @author -
 * @version 1.0.0
 **/
public class ImplementationError extends Error {
    public ImplementationError(String s) {
	super(s);
    }
} // end of ImplementationError
