/**
 * The Director_u83 class for 307-PA1
 * @author -
 **/
package cs307.first;
import threeohseven.*;



public class Director_u83 implements Director {

    public Director_u83(){
    	//NULL constructor, as required
    }
	
	/**
     * Create a builder from a descriptor.
     * @param dd non-null descriptor 
     * @throws ImplementationError if there
     * is no suitable implementation for this descriptor
     **/
    public Builder makeBuilder(Descriptor dd){
    	int low, high;
    	BitVector.Descriptor bvd = (BitVector.Descriptor) dd;
    	low = bvd.getLowerBound();
    	high = bvd.getUpperBound();
    	boolean checked, speed, size;
    	checked = bvd.boundCheckRequired();
		speed = bvd.optimizeSpeed();
		size = bvd.optimizeSpace();
		Builder myBuilder;
		if (size) myBuilder = new Builder_u83 (low, high, checked,
							     speed, size);
		else myBuilder = new BuilderBig_u83(low, high, checked,
							   speed, size);
		return myBuilder;
    }

}// End of Director

