package cs307.first;

import threeohseven.BitVector.Iterator;

public class IteratorB_46 implements Iterator {
	private BitVectorB_46 _bv;
	int _position = 0;
	
	public IteratorB_46(BitVectorB_46 bv) {
		_bv = bv;
	}
	@Override
	public boolean getNext() {
		_position++;
		return _bv.test(_position-1);
	}

	@Override
	public boolean hasNext() {
		if (_position > _bv._max) {
			return false;
		}
		else {
			return true;
		}
	}

	@Override
	public int position() {
		return _position;
	}

	@Override
	public int skipToSet() {
		while (!_bv.test(_position)) {
			_position++;
		}
		return _position;
	}

	@Override
	public int skipToUnset() {
		while (_bv.test(_position)) {
			_position++;
		}
		return _position;
	}

}
