/*****
 * 
 *****/

package cs307.first;

public class BuilderSpace_u49 implements BitVector.Builder {
	
	public BitVector.Descriptor des;
	
	public Object build() {
		return buildBitVector();
	}
	
	public BuilderSpace_u49 (Director.Descriptor base) {
		des = (BitVector.Descriptor) base;
	}
	
	public BitVector buildBitVector() {
		return new BitVectorSpace_u49(des.getLowerBound(), des.getUpperBound(), this);
	}
	
	public BitVector buildBitVector(BitVector val) {
		if (des.equals(((BitVectorSpace_u49) val).descriptor))
			return val.copy();
		else
			throw new cs307.first.ImplementationError("Incompatible Bit Vector Types.");
	}
	
	public boolean equals(Object other) {
		if (other instanceof Director.Builder)
			return compatible((BitVector.Builder) other);
		else
			return false;
	}
	
	public boolean compatible(BitVector.Builder other) {
		if (other instanceof BuilderSpace_u49)
			return des.equals(((BuilderSpace_u49) other).des);
		else
			return false;
	}
}
