package cs307.first.test.u51;

import junit.framework.TestCase;
import junit.framework.Assert;
import cs307.first.*;

public class TestAnd extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void test()
	{
		//first test speed-optimized vector
		Director_51 director = new Director_51();
		//we do not need to set speed-optimize flag, we automatically speed optimize unless space-optimized flag set
		Descriptor_51 desc = new Descriptor_51(0,6,false,false,false);
		Builder_51 builder = director.makeBuilder(desc);
		
		BitVector_51 bv1 = new BitVector_51(desc);
		bv1.set(0);
		bv1.set(1);
		bv1.set(2);
		bv1.set(3);
		bv1.set(4);
		bv1.set(5);
		boolean forAssert = true;
		if(bv1.toString().indexOf("0")!=-1)  //should have no zeros in it
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);

		BitVector_51 bv2 = new BitVector_51(desc);
		
		if(bv2.toString().indexOf("1")!=-1)  //should have no ones in it
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
		

		bv1.and(bv2);
		
		if(bv1.toString().indexOf("1")!=-1)  //should have no ones in it
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
		
		bv1.set(0);
		bv1.set(1);
		bv1.set(2);
		bv1.set(3);
		bv1.set(4);
		bv1.set(5);
		bv2.set(2);
		bv2.set(4);
		bv1.and(bv2);
		
		String holdingString;
		holdingString = bv1.toString();
		System.out.println(holdingString);
		
		if(holdingString.charAt(0)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(2)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(4)=='0')  //should have a one
		{
			forAssert=false;
		}
		else if(holdingString.charAt(6)=='1')  //should have a zero
		{
			forAssert=false;
		}
		else if(holdingString.charAt(8)=='0')  //should have a zone
		{
			forAssert=false;
		}
		else if(holdingString.charAt(10)=='1')  //should have a zero
		{
			forAssert=false;
		}
		Assert.assertTrue(forAssert);
	}
	protected void tearDown() throws Exception {
		super.tearDown();
	}

}
