/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cs307.first;

/**
 * The Director class used to make the decision on which builder to use in order 
 * to try to optimize the implementation for the given use case
 * @author -
 */
public class Director_68 implements Director {

    private static int _upperLimit = 127, _lowerLimit = 0; // During optimization testing.
    													   // Change to public
    
    public Director_68() {
    }
    
    public Builder makeBuilder(Descriptor dd) {
        BitVector.Descriptor bd = (BitVector.Descriptor) dd;
        if ((bd.getLowerBound() >= _lowerLimit && bd.getUpperBound() <= _upperLimit) || bd.getUpperBound()-bd.getLowerBound() < 128) {
            if(bd.optimizeSpeed()){
                return new BuilderBig_68(bd.getLowerBound(), bd.getUpperBound());
            }
            return new BuilderSmall_68(bd.getLowerBound(), bd.getUpperBound());
        }else        {
        	if(bd.getUpperBound()-bd.getLowerBound() < 10000 && bd.optimizeSpace())        	{
        		return new BuilderSmall_68(bd.getLowerBound(), bd.getUpperBound());        		
        	}
        	return new BuilderBig_68(bd.getLowerBound(), bd.getUpperBound());
        }
    }
}
