package test.first.u68;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import cs307.first.BitVector;
import cs307.first.Director;
import cs307.first.Director_68;
import cs307.first.Director.Builder;

public class TestDirector {

	private Director testDirector;
	
	@Before
	public void setUp() throws Exception {
		testDirector = new Director_68();
	}

	@After
	public void tearDown() throws Exception {
		testDirector = null;
	}

	@Test
	public void testDirector_kdosenba() {
		testDirector = new Director_68();
		assertNotNull(testDirector);
	}

	@Test
	public void testMakeBuilder() {
		BitVector.Descriptor testSmall = new BitVector.Descriptor(0, 10, false, false, false);
		Builder myBuilder1 = testDirector.makeBuilder(testSmall);
		assertNotNull(myBuilder1);
		BitVector.Descriptor testLarg = new BitVector.Descriptor(0, 1000, false, false, false);
		Builder myBuilder2 = testDirector.makeBuilder(testLarg);
		assertNotNull(myBuilder2);		
	}

}
