package test.first.u93;

import org.junit.After;
import org.junit.Before;

import cs307.first.u93.Builder_93;
import test.first.u93.DirectorTester_93;
import cs307.first.u93.Director_93;


public class DirectorTester_93 {

	Director_93 dir;
	
	DirectorTester_93(){
		dir = new Director_93();
	}
	
	@Before
	public void setUp() throws Exception {
		dir = new Director_93();
	}

	@After
	public void tearDown() throws Exception {
		dir = null;
	}

	public static void main(String[] args){
		DirectorTester_93 first = new DirectorTester_93();
		System.out.println("\n\n\n=================== Testing Commensing ==================");
		System.out.println("Does makeBuiler make something: " + first.testMakeBuild());
		System.out.println("Builder specs = \n" + first.testBuilderSpecs());
		
		System.out.println("\nTesting complete.  Shutting down");
	}
	
	public boolean testMakeBuild(){
		Builder_93 b = (Builder_93) dir.makeBuilder(dir.dis);
		if(b != null)
			return true;
		return false;
	}
	
	public String testBuilderSpecs(){
		Builder_93 b = (Builder_93) dir.makeBuilder(dir.dis);
		String ans = "Lower Bound = " + b.getLow() + " Upper Bound = " + b.getHigh();
		ans = ans + " optSpeed = " + b.optSpeed() + " checked = " + b.checked();
		return ans;
	}
}
